// k.yokomizo
module CNT (CLK,RESETB,INIT,MAX,ENI,ENO,Q);
   parameter WIDTH = 1 ;
   input  CLK;
   input  RESETB;
   input  INIT;
   input  [WIDTH-1:0] MAX;
   input  ENI;
   output ENO;
   output [WIDTH-1:0] Q;

   reg [WIDTH-1:0] CNT;

always@(posedge CLK or negedge RESETB)
begin
   if(RESETB == 1'b0)            // Reset
      CNT <= 0;
   else   // CLK event
      if (INIT == 1'b1 ) 
        CNT <= 0 ;
      else
         if (ENI == 1'b1) 
            if (CNT == MAX)      
               CNT  <= 0;
            else
               CNT  <= CNT + 1; // count up
end

assign ENO = ((ENI==1'b1)&(CNT==MAX))?1'b1:1'b0;
assign Q = CNT;

endmodule

