// k.yokomizo
module S_WATCH
  (
        CLK,
        RESETB,
        START_SW,
        ADJUST_SW,
        LAP_SW,
        SEG_OUT,
        SEG_SEL
  );

parameter [17:0]BASE_MAX_C = 18'b101100111111111111;
parameter [7:0]LED_CYCLE = 8'b11111111;

input  CLK;
input  RESETB;
input  START_SW;
input  ADJUST_SW;
input  LAP_SW;
output [7:0]SEG_OUT;
output [5:0]SEG_SEL;

wire START;
wire ADJUST;
wire LAP;
wire [3:0]Q_A;
wire [3:0]Q_B;
wire [3:0]Q_C;
wire [3:0]Q_D;
wire  EN_A;
wire  CNT_EN;
wire  WREN;
wire [15:0]WR_DATA;
wire [15:0]MEM_DATA;
wire [4:0]ADR;
wire [4:0]LAP_NO;
wire DATA_SEL;
 

assign WR_DATA = {Q_D,Q_C,Q_B,Q_A};
  
SW_IF SW_IF_U
   (
      .CLK(CLK),
      .RESETB(RESETB),
      .START_SW(START_SW),
      .ADJUST_SW(ADJUST_SW),
      .LAP_SW(LAP_SW),
      .START(START) ,
      .ADJUST(ADJUST) ,
      .LAP(LAP)  );

CTRL CTRL_U
   (
      .CLK(CLK ),
      .RESETB(RESETB),
      .START(START),
      .ADJUST(ADJUST),
      .LAP(LAP),
      .Q_B(Q_B),
      .EN_A(EN_A),
      .CNT_EN(CNT_EN),
      .DATA_SEL(DATA_SEL),
      .WREN(WREN),
      .ADR(ADR),
      .LAP_NO(LAP_NO)
      );

defparam TIMER_U.BASE_MAX_C=BASE_MAX_C;
TIMER TIMER_U
   (
      .CLK (CLK),
      .RESETB(RESETB),
      .ADJUST(ADJUST),
      .CNT_EN(CNT_EN),
      .Q_A(Q_A),
      .Q_B(Q_B),
      .Q_C(Q_C),
      .Q_D(Q_D),
      .EN_A(EN_A) );


defparam OUTPUT_IF_U.LED_CYCLE=LED_CYCLE;
OUTPUT_IF OUTPUT_IF_U
   (
      .CLK(CLK),
      .RESETB(RESETB),
      .Q_A(Q_A),
      .Q_B(Q_B),
      .Q_C(Q_C),
      .Q_D(Q_D),
      .WEN(WREN),
      .CNT_EN(CNT_EN),
      .LAP_NO(LAP_NO ),
      .MEM_DATA(MEM_DATA ),
      .DATA_SEL(DATA_SEL ),
      .SEG_OUT(SEG_OUT),
      .SEG_SEL(SEG_SEL) );

DATA_RAM2 RAM1
   (
      .data(WR_DATA),
      .address(ADR),
      .we(WREN ),
      .q(MEM_DATA) 	);

endmodule












