module TIMER (CLK,RESETB, ADJUST,CNT_EN,
              Q_A,Q_B,Q_C,Q_D,EN_A);
parameter  [17:0]BASE_MAX_C=18'b101100111111111111;
input CLK;
input RESETB;
input ADJUST;
input CNT_EN;
output [3:0]Q_A;
output [3:0]Q_B;
output [3:0]Q_C;
output [3:0]Q_D;
output EN_A;

wire [17:0]Q_BASE ;
wire ENO_BASE ;
wire ENO_A;
wire ENO_B;
wire ENO_C;
wire ENO_D;
parameter [3:0] CNT_10_MAX_C=4'b1001;
wire INIT;

assign EN_A = ENO_A;
assign INIT = ((ADJUST==1'b1)&(CNT_EN==1'b0))?1'b1:1'b0;

  defparam CNT_BASE.WIDTH=18;
  CNT CNT_BASE
     (.CLK(CLK),
      .RESETB(RESETB),
      .INIT(ADJUST),
      .MAX(BASE_MAX_C),
      .ENI(CNT_EN),
      .ENO(ENO_BASE),
      .Q(Q_BASE) );

  defparam CNT_A.WIDTH=4;
  CNT /*#(4)*/ CNT_A
     (.CLK(CLK),
      .RESETB(RESETB),
      .INIT(ADJUST),
      .MAX(CNT_10_MAX_C),
      .ENI(ENO_BASE),
      .ENO(ENO_A),
      .Q(Q_A) );

  defparam CNT_B.WIDTH=4;
  CNT CNT_B
     (.CLK(CLK),
      .RESETB(RESETB),
      .INIT(ADJUST),
      .MAX(CNT_10_MAX_C),
      .ENI(ENO_A),
      .ENO(ENO_B),
      .Q(Q_B) );

  defparam CNT_C.WIDTH=4;
  CNT CNT_C
     (.CLK(CLK),
      .RESETB(RESETB),
      .INIT(ADJUST),
      .MAX(CNT_10_MAX_C),
      .ENI(ENO_B),
      .ENO(ENO_C),
      .Q(Q_C) );

 defparam CNT_D.WIDTH=4;
  CNT CNT_D
     (.CLK(CLK),
      .RESETB(RESETB),
      .INIT(ADJUST),
      .MAX(CNT_10_MAX_C),
      .ENI(ENO_C),
      .ENO(ENO_D),
      .Q(Q_D) );

endmodule





