//k.yokomizo
module T_S_WATCH ;
parameter [17:0]BASE_MAX_C = 18'b000000000000000001;
parameter [7:0]LED_CYCLE = 8'b00000001;

reg  CLK;
reg  RESETB;
reg  START_SW;
reg  ADJUST_SW;
reg  LAP_SW;
wire [7:0]SEG_OUT;
wire [5:0]SEG_SEL;
reg  [3:0]SEG_DATA;
reg  [3:0]SEG_DATA0;
reg  [3:0]SEG_DATA1;
reg  [3:0]SEG_DATA2;
reg  [3:0]SEG_DATA3;
reg  [3:0]SEG_DATA4;
reg  [3:0]SEG_DATA5;
parameter STEP_A = 50 ;
parameter STEP_B = 500 ;
 
defparam DUT.BASE_MAX_C=BASE_MAX_C;
defparam DUT.LED_CYCLE = LED_CYCLE;
S_WATCH DUT
  ( .CLK(CLK),
    .RESETB(RESETB),
    .START_SW(START_SW),
    .ADJUST_SW(ADJUST_SW),
    .LAP_SW(LAP_SW),
    .SEG_OUT(SEG_OUT),
    .SEG_SEL(SEG_SEL) );

initial
 $dumpvars;

always 
begin
   CLK <= 1'b0;
   #(STEP_A/2) ;
   CLK <= 1'b1;
   #(STEP_A/2) ;
end 

initial
begin
   RESETB <= 1'b0;
   START_SW <=1'b1;
   ADJUST_SW <=1'b1;
   LAP_SW <=1'b1;
   #(STEP_A) ;
   RESETB <= 1'b1;
   #(STEP_A*20) ;
   //* start ******************** 
   START_SW <=1'b0;               
   #(STEP_B*20) ;
   START_SW <=1'b1;
   #(STEP_B*20) ;
   //* stop *********************
   START_SW <=1'b0;               
   #(STEP_B*20) ;
   START_SW <=1'b1;
   #(STEP_B*20) ;
   //* start ******************** 
   START_SW <=1'b0;
   #(STEP_B*20) ;
   START_SW <=1'b1;
   #(STEP_B*20) ;
   //* adjust********************
   ADJUST_SW <=1'b0;
   #(STEP_B*20) ;
   ADJUST_SW <=1'b1;
   #(STEP_B*20) ;
   //* stop *********************
   START_SW <=1'b0;      
   #(STEP_B*20) ;
   START_SW <=1'b1;
   #(STEP_B*20) ;
   //* adjust********************
   ADJUST_SW <=1'b0;
   #(STEP_B*20) ;
   ADJUST_SW <=1'b1;
   #(STEP_B*20) ;
   //* start ******************** 
   START_SW <=1'b0; 
   #(STEP_B*20) ;
   START_SW <=1'b1;                
   #(STEP_B*20) ;
   //* lap1  ******************** 
   LAP_SW <=1'b0;
   #(STEP_B*20) ;
   LAP_SW <=1'b1;             
   #(STEP_B*200) ;
   //* lap2  ******************** 
   LAP_SW <=1'b0;                    
   #(STEP_B*20) ;
   LAP_SW <=1'b1;
   #(STEP_B*200) ;
   //* stop *********************
   START_SW <=1'b0;    
   #(STEP_B*20) ;
   START_SW <=1'b1;              
   #(STEP_B*20) ;
   //* lap1  ******************** 
   LAP_SW <=1'b0;
   #(STEP_B*20) ;
   LAP_SW <=1'b1;             
   #(STEP_B*20) ;
   //* lap2  ******************** 
   LAP_SW <=1'b0; 
   #(STEP_B*20) ;
   LAP_SW <=1'b1;  
   #(STEP_B*20) ;
   //* lap3  ********************
   LAP_SW <=1'b0;
   #(STEP_B*20) ;
   LAP_SW <=1'b1;
   #(STEP_B*20) ;
   $finish;
end

always@(SEG_OUT)
  begin
    case (SEG_OUT) 
      8'b11111100: SEG_DATA <= 4'b0000;
      8'b01100000: SEG_DATA <= 4'b0001;
      8'b11011010: SEG_DATA <= 4'b0010;
      8'b11110010: SEG_DATA <= 4'b0011;
      8'b01100110: SEG_DATA <= 4'b0100;
      8'b10110110: SEG_DATA <= 4'b0101;
      8'b10111110: SEG_DATA <= 4'b0110;
      8'b11100100: SEG_DATA <= 4'b0111;
      8'b11111110: SEG_DATA <= 4'b1000; ////8
      8'b11100110: SEG_DATA <= 4'b1001; ////9
      8'b11101110: SEG_DATA <= 4'b1010; ////A
      8'b00111110: SEG_DATA <= 4'b1011; ////b
      8'b10011100: SEG_DATA <= 4'b1100; ////c
      8'b01111010: SEG_DATA <= 4'b1101; ////d
      8'b01011110: SEG_DATA <= 4'b1110; ////e
      8'b10001110: SEG_DATA <= 4'b1111; ////f
      default:     SEG_DATA <= 4'b1111;
    endcase
  end

always@(SEG_DATA or SEG_SEL)
  begin
    if (SEG_SEL==6'b111110)
      SEG_DATA0 <= SEG_DATA;
    if (SEG_SEL==6'b111101) 
      SEG_DATA1 <= SEG_DATA;
    if (SEG_SEL==6'b111011) 
      SEG_DATA2 <= SEG_DATA;
    if (SEG_SEL==6'b110111) 
      SEG_DATA3 <= SEG_DATA;
    if (SEG_SEL==6'b101111) 
      SEG_DATA4 <= SEG_DATA;
    if (SEG_SEL==6'b011111) 
      SEG_DATA5 <= SEG_DATA;
  end
  
endmodule 
